/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TARMAGENCIASUCURSAL")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tarmagenciasucursal.findAll", query = "SELECT t FROM Tarmagenciasucursal t"),
    @NamedQuery(name = "Tarmagenciasucursal.findByCagencia", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.cagencia = :cagencia"),
    @NamedQuery(name = "Tarmagenciasucursal.findByDireccion", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.direccion = :direccion"),
    @NamedQuery(name = "Tarmagenciasucursal.findByTelefono", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.telefono = :telefono"),
    @NamedQuery(name = "Tarmagenciasucursal.findByCorreo", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.correo = :correo"),
    @NamedQuery(name = "Tarmagenciasucursal.findByResponsable", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.responsable = :responsable"),
    @NamedQuery(name = "Tarmagenciasucursal.findByFautorizacion", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.fautorizacion = :fautorizacion"),
    @NamedQuery(name = "Tarmagenciasucursal.findByNombre", query = "SELECT t FROM Tarmagenciasucursal t WHERE t.nombre = :nombre")})
public class Tarmagenciasucursal implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "CAGENCIA")
    private Long cagencia;
    @Column(name = "DIRECCION")
    private String direccion;
    @Column(name = "TELEFONO")
    private String telefono;
    @Column(name = "CORREO")
    private String correo;
    @Column(name = "RESPONSABLE")
    private String responsable;
    @Column(name = "FAUTORIZACION")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fautorizacion;
    @Column(name = "NOMBRE")
    private String nombre;
    @JoinTable(name = "TARMAGENCIAARMA", joinColumns = {
        @JoinColumn(name = "CAGENCIA", referencedColumnName = "CAGENCIA")}, inverseJoinColumns = {
        @JoinColumn(name = "CARMA", referencedColumnName = "CARMA")})
    @ManyToMany
    private Collection<Tarmarmas> tarmarmasCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "tarmagenciasucursal")
    private Collection<Tarmsolicitudagenciasucursal> tarmsolicitudagenciasucursalCollection;
    @JoinColumn(name = "PERSONCODE", referencedColumnName = "PERSONCODE")
    @ManyToOne
    private Tcustperson personcode;
    @JoinColumns({
        @JoinColumn(name = "TIPO", referencedColumnName = "CATALOG"),
        @JoinColumn(name = "TIPOCODIGO", referencedColumnName = "CATALOGCODE")})
    @ManyToOne
    private Tgenecatalogdetail tgenecatalogdetail;
    @JoinColumns({
        @JoinColumn(name = "ESTADO", referencedColumnName = "CATALOG"),
        @JoinColumn(name = "ESTADOCODIGO", referencedColumnName = "CATALOGCODE")})
    @ManyToOne
    private Tgenecatalogdetail tgenecatalogdetail1;
    @JoinColumns({
        @JoinColumn(name = "COUNTRYCODE", referencedColumnName = "COUNTRYCODE"),
        @JoinColumn(name = "PROVINCECODE", referencedColumnName = "PROVINCECODE"),
        @JoinColumn(name = "CANTONCODE", referencedColumnName = "CANTONCODE"),
        @JoinColumn(name = "CITYCODE", referencedColumnName = "CITYCODE")})
    @ManyToOne
    private Tgenecity tgenecity;
    @JoinColumns({
        @JoinColumn(name = "COUNTRYCODE", referencedColumnName = "COUNTRYCODE"),
        @JoinColumn(name = "PROVINCECODE", referencedColumnName = "PROVINCECODE"),
        @JoinColumn(name = "CANTONCODE", referencedColumnName = "CANTONCODE"),
        @JoinColumn(name = "PARROQUIACODE", referencedColumnName = "PARROQUIACODE")})
    @ManyToOne
    private Tgeneparroquia tgeneparroquia;

    public Tarmagenciasucursal() {
    }

    public Tarmagenciasucursal(Long cagencia) {
        this.cagencia = cagencia;
    }

    public Long getCagencia() {
        return cagencia;
    }

    public void setCagencia(Long cagencia) {
        this.cagencia = cagencia;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public String getTelefono() {
        return telefono;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public String getCorreo() {
        return correo;
    }

    public void setCorreo(String correo) {
        this.correo = correo;
    }

    public String getResponsable() {
        return responsable;
    }

    public void setResponsable(String responsable) {
        this.responsable = responsable;
    }

    public Date getFautorizacion() {
        return fautorizacion;
    }

    public void setFautorizacion(Date fautorizacion) {
        this.fautorizacion = fautorizacion;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    @XmlTransient
    public Collection<Tarmarmas> getTarmarmasCollection() {
        return tarmarmasCollection;
    }

    public void setTarmarmasCollection(Collection<Tarmarmas> tarmarmasCollection) {
        this.tarmarmasCollection = tarmarmasCollection;
    }

    @XmlTransient
    public Collection<Tarmsolicitudagenciasucursal> getTarmsolicitudagenciasucursalCollection() {
        return tarmsolicitudagenciasucursalCollection;
    }

    public void setTarmsolicitudagenciasucursalCollection(Collection<Tarmsolicitudagenciasucursal> tarmsolicitudagenciasucursalCollection) {
        this.tarmsolicitudagenciasucursalCollection = tarmsolicitudagenciasucursalCollection;
    }

    public Tcustperson getPersoncode() {
        return personcode;
    }

    public void setPersoncode(Tcustperson personcode) {
        this.personcode = personcode;
    }

    public Tgenecatalogdetail getTgenecatalogdetail() {
        return tgenecatalogdetail;
    }

    public void setTgenecatalogdetail(Tgenecatalogdetail tgenecatalogdetail) {
        this.tgenecatalogdetail = tgenecatalogdetail;
    }

    public Tgenecatalogdetail getTgenecatalogdetail1() {
        return tgenecatalogdetail1;
    }

    public void setTgenecatalogdetail1(Tgenecatalogdetail tgenecatalogdetail1) {
        this.tgenecatalogdetail1 = tgenecatalogdetail1;
    }

    public Tgenecity getTgenecity() {
        return tgenecity;
    }

    public void setTgenecity(Tgenecity tgenecity) {
        this.tgenecity = tgenecity;
    }

    public Tgeneparroquia getTgeneparroquia() {
        return tgeneparroquia;
    }

    public void setTgeneparroquia(Tgeneparroquia tgeneparroquia) {
        this.tgeneparroquia = tgeneparroquia;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (cagencia != null ? cagencia.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarmagenciasucursal)) {
            return false;
        }
        Tarmagenciasucursal other = (Tarmagenciasucursal) object;
        if ((this.cagencia == null && other.cagencia != null) || (this.cagencia != null && !this.cagencia.equals(other.cagencia))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tarmagenciasucursal[ cagencia=" + cagencia + " ]";
    }
    
}
